#![doc = "Peripheral access API for SOC microcontrollers (generated using svd2rust v0.20.0 ( ))\n\nYou can find an overview of the generated API [here].\n\nAPI features to be included in the [next]
svd2rust release can be generated by cloning the svd2rust [repository], checking out the above commit, and running `cargo doc --open`.\n\n[here]: https://docs.rs/svd2rust/0.20.0/svd2rust/#peripheral-api\n[next]: https://github.com/rust-embedded/svd2rust/blob/master/CHANGELOG.md#unreleased\n[repository]: https://github.com/rust-embedded/svd2rust"]
#![deny(const_err)]
#![deny(dead_code)]
#![deny(improper_ctypes)]
#![deny(missing_docs)]
#![deny(no_mangle_generic_items)]
#![deny(non_shorthand_field_patterns)]
#![deny(overflowing_literals)]
#![deny(path_statements)]
#![deny(patterns_in_fns_without_body)]
#![deny(private_in_public)]
#![deny(unconditional_recursion)]
#![deny(unused_allocation)]
#![deny(unused_comparisons)]
#![deny(unused_parens)]
#![deny(while_true)]
#![allow(non_camel_case_types)]
#![allow(non_snake_case)]
#![no_std]
use core::marker::PhantomData;
use core::ops::Deref;
#[allow(unused_imports)]
use generic::*;
#[doc = r"Common register and bit access and modify traits"]
pub mod generic {
    use core::marker;
    #[doc = " Raw register type"]
    pub trait RegisterSpec {
        #[doc = " Raw register type (`u8`, `u16`, `u32`, ...)."]
        type Ux: Copy;
    }
    #[doc = " Trait implemented by readable registers to enable the `read` method."]
    #[doc = ""]
    #[doc = " Registers marked with `Writable` can be also `modify`'ed."]
    pub trait Readable: RegisterSpec {
        #[doc = " Result from a call to `read` and argument to `modify`."]
        type Reader: From<R<Self>> + core::ops::Deref<Target = R<Self>>;
    }
    #[doc = " Trait implemented by writeable registers."]
    #[doc = ""]
    #[doc = " This enables the  `write`, `write_with_zero` and `reset` methods."]
    #[doc = ""]
    #[doc = " Registers marked with `Readable` can be also `modify`'ed."]
    pub trait Writable: RegisterSpec {
        #[doc = " Writer type argument to `write`, et al."]
        type Writer: From<W<Self>> + core::ops::DerefMut<Target = W<Self>>;
    }
    #[doc = " Reset value of the register."]
    #[doc = ""]
    #[doc = " This value is the initial value for the `write` method. It can also be directly written to the"]
    #[doc = " register by using the `reset` method."]
    pub trait Resettable: RegisterSpec {
        #[doc = " Reset value of the register."]
        fn reset_value() -> Self::Ux;
    }
    #[doc = " This structure provides volatile access to registers."]
    #[repr(transparent)]
    pub struct Reg<REG: RegisterSpec> {
        register: vcell::VolatileCell<REG::Ux>,
        _marker: marker::PhantomData<REG>,
    }
    unsafe impl<REG: RegisterSpec> Send for Reg<REG> where REG::Ux: Send {}
    impl<REG: RegisterSpec> Reg<REG> {
        #[doc = " Returns the underlying memory address of register."]
        #[doc = ""]
        #[doc = " ```ignore"]
        #[doc = " let reg_ptr = periph.reg.as_ptr();"]
        #[doc = " ```"]
        #[inline(always)]
        pub fn as_ptr(&self) -> *mut REG::Ux {
            self.register.as_ptr()
        }
    }
    impl<REG: Readable> Reg<REG> {
        #[doc = " Reads the contents of a `Readable` register."]
        #[doc = ""]
        #[doc = " You can read the raw contents of a register by using `bits`:"]
        #[doc = " ```ignore"]
        #[doc = " let bits = periph.reg.read().bits();"]
        #[doc = " ```"]
        #[doc = " or get the content of a particular field of a register:"]
        #[doc = " ```ignore"]
        #[doc = " let reader = periph.reg.read();"]
        #[doc = " let bits = reader.field1().bits();"]
        #[doc = " let flag = reader.field2().bit_is_set();"]
        #[doc = " ```"]
        #[inline(always)]
        pub fn read(&self) -> REG::Reader {
            REG::Reader::from(R {
                bits: self.register.get(),
                _reg: marker::PhantomData,
            })
        }
    }
    impl<REG: Resettable + Writable> Reg<REG> {
        #[doc = " Writes the reset value to `Writable` register."]
        #[doc = ""]
        #[doc = " Resets the register to its initial state."]
        #[inline(always)]
        pub fn reset(&self) {
            self.register.set(REG::reset_value())
        }
        #[doc = " Writes bits to a `Writable` register."]
        #[doc = ""]
        #[doc = " You can write raw bits into a register:"]
        #[doc = " ```ignore"]
        #[doc = " periph.reg.write(|w| unsafe { w.bits(rawbits) });"]
        #[doc = " ```"]
        #[doc = " or write only the fields you need:"]
        #[doc = " ```ignore"]
        #[doc = " periph.reg.write(|w| w"]
        #[doc = "     .field1().bits(newfield1bits)"]
        #[doc = "     .field2().set_bit()"]
        #[doc = "     .field3().variant(VARIANT)"]
        #[doc = " );"]
        #[doc = " ```"]
        #[doc = " In the latter case, other fields will be set to their reset value."]
        #[inline(always)]
        pub fn write<F>(&self, f: F)
        where
            F: FnOnce(&mut REG::Writer) -> &mut W<REG>,
        {
            self.register.set(
                f(&mut REG::Writer::from(W {
                    bits: REG::reset_value(),
                    _reg: marker::PhantomData,
                }))
                .bits,
            );
        }
    }
    impl<REG: Writable> Reg<REG>
    where
        REG::Ux: Default,
    {
        #[doc = " Writes 0 to a `Writable` register."]
        #[doc = ""]
        #[doc = " Similar to `write`, but unused bits will contain 0."]
        #[inline(always)]
        pub unsafe fn write_with_zero<F>(&self, f: F)
        where
            F: FnOnce(&mut REG::Writer) -> &mut W<REG>,
        {
            self.register.set(
                (*f(&mut REG::Writer::from(W {
                    bits: REG::Ux::default(),
                    _reg: marker::PhantomData,
                })))
                .bits,
            );
        }
    }
    impl<REG: Readable + Writable> Reg<REG> {
        #[doc = " Modifies the contents of the register by reading and then writing it."]
        #[doc = ""]
        #[doc = " E.g. to do a read-modify-write sequence to change parts of a register:"]
        #[doc = " ```ignore"]
        #[doc = " periph.reg.modify(|r, w| unsafe { w.bits("]
        #[doc = "    r.bits() | 3"]
        #[doc = " ) });"]
        #[doc = " ```"]
        #[doc = " or"]
        #[doc = " ```ignore"]
        #[doc = " periph.reg.modify(|_, w| w"]
        #[doc = "     .field1().bits(newfield1bits)"]
        #[doc = "     .field2().set_bit()"]
        #[doc = "     .field3().variant(VARIANT)"]
        #[doc = " );"]
        #[doc = " ```"]
        #[doc = " Other fields will have the value they had before the call to `modify`."]
        #[inline(always)]
        pub fn modify<F>(&self, f: F)
        where
            for<'w> F: FnOnce(&REG::Reader, &'w mut REG::Writer) -> &'w mut W<REG>,
        {
            let bits = self.register.get();
            self.register.set(
                f(
                    &REG::Reader::from(R {
                        bits,
                        _reg: marker::PhantomData,
                    }),
                    &mut REG::Writer::from(W {
                        bits,
                        _reg: marker::PhantomData,
                    }),
                )
                .bits,
            );
        }
    }
    #[doc = " Register reader."]
    #[doc = ""]
    #[doc = " Result of the `read` methods of registers. Also used as a closure argument in the `modify`"]
    #[doc = " method."]
    pub struct R<REG: RegisterSpec + ?Sized> {
        pub(crate) bits: REG::Ux,
        _reg: marker::PhantomData<REG>,
    }
    impl<REG: RegisterSpec> R<REG> {
        #[doc = " Reads raw bits from register."]
        #[inline(always)]
        pub fn bits(&self) -> REG::Ux {
            self.bits
        }
    }
    impl<REG: RegisterSpec, FI> PartialEq<FI> for R<REG>
    where
        REG::Ux: PartialEq,
        FI: Copy + Into<REG::Ux>,
    {
        #[inline(always)]
        fn eq(&self, other: &FI) -> bool {
            self.bits.eq(&(*other).into())
        }
    }
    #[doc = " Register writer."]
    #[doc = ""]
    #[doc = " Used as an argument to the closures in the `write` and `modify` methods of the register."]
    pub struct W<REG: RegisterSpec + ?Sized> {
        #[doc = "Writable bits"]
        pub(crate) bits: REG::Ux,
        _reg: marker::PhantomData<REG>,
    }
    impl<REG: RegisterSpec> W<REG> {
        #[doc = " Writes raw bits to the register."]
        #[inline(always)]
        pub unsafe fn bits(&mut self, bits: REG::Ux) -> &mut Self {
            self.bits = bits;
            self
        }
    }
    #[doc = " Field reader."]
    #[doc = ""]
    #[doc = " Result of the `read` methods of fields."]
    pub struct FieldReader<U, T> {
        pub(crate) bits: U,
        _reg: marker::PhantomData<T>,
    }
    impl<U, T> FieldReader<U, T>
    where
        U: Copy,
    {
        #[doc = " Creates a new instance of the reader."]
        #[allow(unused)]
        #[inline(always)]
        pub(crate) fn new(bits: U) -> Self {
            Self {
                bits,
                _reg: marker::PhantomData,
            }
        }
        #[doc = " Reads raw bits from field."]
        #[inline(always)]
        pub fn bits(&self) -> U {
            self.bits
        }
    }
    impl<U, T, FI> PartialEq<FI> for FieldReader<U, T>
    where
        U: PartialEq,
        FI: Copy + Into<U>,
    {
        #[inline(always)]
        fn eq(&self, other: &FI) -> bool {
            self.bits.eq(&(*other).into())
        }
    }
    impl<FI> FieldReader<bool, FI> {
        #[doc = " Value of the field as raw bits."]
        #[inline(always)]
        pub fn bit(&self) -> bool {
            self.bits
        }
        #[doc = " Returns `true` if the bit is clear (0)."]
        #[inline(always)]
        pub fn bit_is_clear(&self) -> bool {
            !self.bit()
        }
        #[doc = " Returns `true` if the bit is set (1)."]
        #[inline(always)]
        pub fn bit_is_set(&self) -> bool {
            self.bit()
        }
    }
}
#[cfg(feature = "rt")]
extern "C" {}
#[doc(hidden)]
pub union Vector {
    pub _handler: unsafe extern "C" fn(),
    pub _reserved: usize,
}
#[cfg(feature = "rt")]
#[doc(hidden)]
#[no_mangle]
pub static __EXTERNAL_INTERRUPTS: [Vector; 0] = [];
#[doc = "SPIFLASH_PHY"]
pub struct SPIFLASH_PHY {
    _marker: PhantomData<*const ()>,
}
unsafe impl Send for SPIFLASH_PHY {}
impl SPIFLASH_PHY {
    #[doc = r"Pointer to the register block"]
    pub const PTR: *const spiflash_phy::RegisterBlock = 0xf000_0800 as *const _;
    #[doc = r"Return the pointer to the register block"]
    #[inline(always)]
    pub const fn ptr() -> *const spiflash_phy::RegisterBlock {
        Self::PTR
    }
}
impl Deref for SPIFLASH_PHY {
    type Target = spiflash_phy::RegisterBlock;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        unsafe { &*Self::PTR }
    }
}
impl core::fmt::Debug for SPIFLASH_PHY {
    fn fmt(&self, f: &mut core::fmt::Formatter) -> core::fmt::Result {
        f.debug_struct("SPIFLASH_PHY").finish()
    }
}
#[doc = "SPIFLASH_PHY"]
pub mod spiflash_phy {
    #[doc = r"Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - "]
        pub clk_divisor: crate::Reg<clk_divisor::CLK_DIVISOR_SPEC>,
    }
    #[doc = "CLK_DIVISOR register accessor: an alias for `Reg<CLK_DIVISOR_SPEC>`"]
    pub type CLK_DIVISOR = crate::Reg<clk_divisor::CLK_DIVISOR_SPEC>;
    #[doc = ""]
    pub mod clk_divisor {
        #[doc = "Register `CLK_DIVISOR` reader"]
        pub struct R(crate::R<CLK_DIVISOR_SPEC>);
        impl core::ops::Deref for R {
            type Target = crate::R<CLK_DIVISOR_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl From<crate::R<CLK_DIVISOR_SPEC>> for R {
            #[inline(always)]
            fn from(reader: crate::R<CLK_DIVISOR_SPEC>) -> Self {
                R(reader)
            }
        }
        #[doc = "Register `CLK_DIVISOR` writer"]
        pub struct W(crate::W<CLK_DIVISOR_SPEC>);
        impl core::ops::Deref for W {
            type Target = crate::W<CLK_DIVISOR_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl core::ops::DerefMut for W {
            #[inline(always)]
            fn deref_mut(&mut self) -> &mut Self::Target {
                &mut self.0
            }
        }
        impl From<crate::W<CLK_DIVISOR_SPEC>> for W {
            #[inline(always)]
            fn from(writer: crate::W<CLK_DIVISOR_SPEC>) -> Self {
                W(writer)
            }
        }
        #[doc = "Field `clk_divisor` reader - "]
        pub struct CLK_DIVISOR_R(crate::FieldReader<u8, u8>);
        impl CLK_DIVISOR_R {
            #[inline(always)]
            pub(crate) fn new(bits: u8) -> Self {
                CLK_DIVISOR_R(crate::FieldReader::new(bits))
            }
        }
        impl core::ops::Deref for CLK_DIVISOR_R {
            type Target = crate::FieldReader<u8, u8>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        #[doc = "Field `clk_divisor` writer - "]
        pub struct CLK_DIVISOR_W<'a> {
            w: &'a mut W,
        }
        impl<'a> CLK_DIVISOR_W<'a> {
            #[doc = r"Writes raw bits to the field"]
            #[inline(always)]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                self.w.bits = (self.w.bits & !0xff) | (value as u32 & 0xff);
                self.w
            }
        }
        impl R {
            #[doc = "Bits 0:7"]
            #[inline(always)]
            pub fn clk_divisor(&self) -> CLK_DIVISOR_R {
                CLK_DIVISOR_R::new((self.bits & 0xff) as u8)
            }
        }
        impl W {
            #[doc = "Bits 0:7"]
            #[inline(always)]
            pub fn clk_divisor(&mut self) -> CLK_DIVISOR_W {
                CLK_DIVISOR_W { w: self }
            }
            #[doc = "Writes raw bits to the register."]
            #[inline(always)]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.0.bits(bits);
                self
            }
        }
        #[doc = "\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_divisor](index.html) module"]
        pub struct CLK_DIVISOR_SPEC;
        impl crate::RegisterSpec for CLK_DIVISOR_SPEC {
            type Ux = u32;
        }
        #[doc = "`read()` method returns [clk_divisor::R](R) reader structure"]
        impl crate::Readable for CLK_DIVISOR_SPEC {
            type Reader = R;
        }
        #[doc = "`write(|w| ..)` method takes [clk_divisor::W](W) writer structure"]
        impl crate::Writable for CLK_DIVISOR_SPEC {
            type Writer = W;
        }
        #[doc = "`reset()` method sets CLK_DIVISOR to value 0"]
        impl crate::Resettable for CLK_DIVISOR_SPEC {
            #[inline(always)]
            fn reset_value() -> Self::Ux {
                0
            }
        }
    }
}
#[doc = "CAM_CONTROL"]
pub struct CAM_CONTROL {
    _marker: PhantomData<*const ()>,
}
unsafe impl Send for CAM_CONTROL {}
impl CAM_CONTROL {
    #[doc = r"Pointer to the register block"]
    pub const PTR: *const cam_control::RegisterBlock = 0xf000_1000 as *const _;
    #[doc = r"Return the pointer to the register block"]
    #[inline(always)]
    pub const fn ptr() -> *const cam_control::RegisterBlock {
        Self::PTR
    }
}
impl Deref for CAM_CONTROL {
    type Target = cam_control::RegisterBlock;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        unsafe { &*Self::PTR }
    }
}
impl core::fmt::Debug for CAM_CONTROL {
    fn fmt(&self, f: &mut core::fmt::Formatter) -> core::fmt::Result {
        f.debug_struct("CAM_CONTROL").finish()
    }
}
#[doc = "CAM_CONTROL"]
pub mod cam_control {
    #[doc = r"Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Set when transfer start is requested and reset when transfer is complete."]
        pub running: crate::Reg<running::RUNNING_SPEC>,
        #[doc = "0x04 - Device may be started only when idle."]
        pub idle: crate::Reg<idle::IDLE_SPEC>,
        #[doc = "0x08 - Write a 1 to this field to force the device to reset"]
        pub reset: crate::Reg<reset::RESET_SPEC>,
        #[doc = "0x0c - Writing a 1 to this field while idle starts the transfer."]
        pub start_run: crate::Reg<start_run::START_RUN_SPEC>,
        #[doc = "0x10 - Writing a 1 to this field while running waits for the start of the next row."]
        pub wait_row: crate::Reg<wait_row::WAIT_ROW_SPEC>,
        #[doc = "0x14 - Whether we have 4 bytes of pixel data ready."]
        pub pixels_ready: crate::Reg<pixels_ready::PIXELS_READY_SPEC>,
        #[doc = "0x18 - 4 bytes of pixel data."]
        pub pixels: crate::Reg<pixels::PIXELS_SPEC>,
    }
    #[doc = "RUNNING register accessor: an alias for `Reg<RUNNING_SPEC>`"]
    pub type RUNNING = crate::Reg<running::RUNNING_SPEC>;
    #[doc = "Set when transfer start is requested and reset when transfer is complete."]
    pub mod running {
        #[doc = "Register `RUNNING` reader"]
        pub struct R(crate::R<RUNNING_SPEC>);
        impl core::ops::Deref for R {
            type Target = crate::R<RUNNING_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl From<crate::R<RUNNING_SPEC>> for R {
            #[inline(always)]
            fn from(reader: crate::R<RUNNING_SPEC>) -> Self {
                R(reader)
            }
        }
        #[doc = "Register `RUNNING` writer"]
        pub struct W(crate::W<RUNNING_SPEC>);
        impl core::ops::Deref for W {
            type Target = crate::W<RUNNING_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl core::ops::DerefMut for W {
            #[inline(always)]
            fn deref_mut(&mut self) -> &mut Self::Target {
                &mut self.0
            }
        }
        impl From<crate::W<RUNNING_SPEC>> for W {
            #[inline(always)]
            fn from(writer: crate::W<RUNNING_SPEC>) -> Self {
                W(writer)
            }
        }
        #[doc = "Field `running` reader - "]
        pub struct RUNNING_R(crate::FieldReader<bool, bool>);
        impl RUNNING_R {
            #[inline(always)]
            pub(crate) fn new(bits: bool) -> Self {
                RUNNING_R(crate::FieldReader::new(bits))
            }
        }
        impl core::ops::Deref for RUNNING_R {
            type Target = crate::FieldReader<bool, bool>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        #[doc = "Field `running` writer - "]
        pub struct RUNNING_W<'a> {
            w: &'a mut W,
        }
        impl<'a> RUNNING_W<'a> {
            #[doc = r"Sets the field bit"]
            #[inline(always)]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r"Clears the field bit"]
            #[inline(always)]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r"Writes raw bits to the field"]
            #[inline(always)]
            pub fn bit(self, value: bool) -> &'a mut W {
                self.w.bits = (self.w.bits & !0x01) | (value as u32 & 0x01);
                self.w
            }
        }
        impl R {
            #[doc = "Bit 0"]
            #[inline(always)]
            pub fn running(&self) -> RUNNING_R {
                RUNNING_R::new((self.bits & 0x01) != 0)
            }
        }
        impl W {
            #[doc = "Bit 0"]
            #[inline(always)]
            pub fn running(&mut self) -> RUNNING_W {
                RUNNING_W { w: self }
            }
            #[doc = "Writes raw bits to the register."]
            #[inline(always)]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.0.bits(bits);
                self
            }
        }
        #[doc = "Set when transfer start is requested and reset when transfer is complete.\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [running](index.html) module"]
        pub struct RUNNING_SPEC;
        impl crate::RegisterSpec for RUNNING_SPEC {
            type Ux = u32;
        }
        #[doc = "`read()` method returns [running::R](R) reader structure"]
        impl crate::Readable for RUNNING_SPEC {
            type Reader = R;
        }
        #[doc = "`write(|w| ..)` method takes [running::W](W) writer structure"]
        impl crate::Writable for RUNNING_SPEC {
            type Writer = W;
        }
        #[doc = "`reset()` method sets RUNNING to value 0"]
        impl crate::Resettable for RUNNING_SPEC {
            #[inline(always)]
            fn reset_value() -> Self::Ux {
                0
            }
        }
    }
    #[doc = "IDLE register accessor: an alias for `Reg<IDLE_SPEC>`"]
    pub type IDLE = crate::Reg<idle::IDLE_SPEC>;
    #[doc = "Device may be started only when idle."]
    pub mod idle {
        #[doc = "Register `IDLE` reader"]
        pub struct R(crate::R<IDLE_SPEC>);
        impl core::ops::Deref for R {
            type Target = crate::R<IDLE_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl From<crate::R<IDLE_SPEC>> for R {
            #[inline(always)]
            fn from(reader: crate::R<IDLE_SPEC>) -> Self {
                R(reader)
            }
        }
        #[doc = "Register `IDLE` writer"]
        pub struct W(crate::W<IDLE_SPEC>);
        impl core::ops::Deref for W {
            type Target = crate::W<IDLE_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl core::ops::DerefMut for W {
            #[inline(always)]
            fn deref_mut(&mut self) -> &mut Self::Target {
                &mut self.0
            }
        }
        impl From<crate::W<IDLE_SPEC>> for W {
            #[inline(always)]
            fn from(writer: crate::W<IDLE_SPEC>) -> Self {
                W(writer)
            }
        }
        #[doc = "Field `idle` reader - "]
        pub struct IDLE_R(crate::FieldReader<bool, bool>);
        impl IDLE_R {
            #[inline(always)]
            pub(crate) fn new(bits: bool) -> Self {
                IDLE_R(crate::FieldReader::new(bits))
            }
        }
        impl core::ops::Deref for IDLE_R {
            type Target = crate::FieldReader<bool, bool>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        #[doc = "Field `idle` writer - "]
        pub struct IDLE_W<'a> {
            w: &'a mut W,
        }
        impl<'a> IDLE_W<'a> {
            #[doc = r"Sets the field bit"]
            #[inline(always)]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r"Clears the field bit"]
            #[inline(always)]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r"Writes raw bits to the field"]
            #[inline(always)]
            pub fn bit(self, value: bool) -> &'a mut W {
                self.w.bits = (self.w.bits & !0x01) | (value as u32 & 0x01);
                self.w
            }
        }
        impl R {
            #[doc = "Bit 0"]
            #[inline(always)]
            pub fn idle(&self) -> IDLE_R {
                IDLE_R::new((self.bits & 0x01) != 0)
            }
        }
        impl W {
            #[doc = "Bit 0"]
            #[inline(always)]
            pub fn idle(&mut self) -> IDLE_W {
                IDLE_W { w: self }
            }
            #[doc = "Writes raw bits to the register."]
            #[inline(always)]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.0.bits(bits);
                self
            }
        }
        #[doc = "Device may be started only when idle.\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [idle](index.html) module"]
        pub struct IDLE_SPEC;
        impl crate::RegisterSpec for IDLE_SPEC {
            type Ux = u32;
        }
        #[doc = "`read()` method returns [idle::R](R) reader structure"]
        impl crate::Readable for IDLE_SPEC {
            type Reader = R;
        }
        #[doc = "`write(|w| ..)` method takes [idle::W](W) writer structure"]
        impl crate::Writable for IDLE_SPEC {
            type Writer = W;
        }
        #[doc = "`reset()` method sets IDLE to value 0"]
        impl crate::Resettable for IDLE_SPEC {
            #[inline(always)]
            fn reset_value() -> Self::Ux {
                0
            }
        }
    }
    #[doc = "RESET register accessor: an alias for `Reg<RESET_SPEC>`"]
    pub type RESET = crate::Reg<reset::RESET_SPEC>;
    #[doc = "Write a 1 to this field to force the device to reset"]
    pub mod reset {
        #[doc = "Register `RESET` reader"]
        pub struct R(crate::R<RESET_SPEC>);
        impl core::ops::Deref for R {
            type Target = crate::R<RESET_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl From<crate::R<RESET_SPEC>> for R {
            #[inline(always)]
            fn from(reader: crate::R<RESET_SPEC>) -> Self {
                R(reader)
            }
        }
        #[doc = "Register `RESET` writer"]
        pub struct W(crate::W<RESET_SPEC>);
        impl core::ops::Deref for W {
            type Target = crate::W<RESET_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl core::ops::DerefMut for W {
            #[inline(always)]
            fn deref_mut(&mut self) -> &mut Self::Target {
                &mut self.0
            }
        }
        impl From<crate::W<RESET_SPEC>> for W {
            #[inline(always)]
            fn from(writer: crate::W<RESET_SPEC>) -> Self {
                W(writer)
            }
        }
        #[doc = "Field `reset` reader - "]
        pub struct RESET_R(crate::FieldReader<bool, bool>);
        impl RESET_R {
            #[inline(always)]
            pub(crate) fn new(bits: bool) -> Self {
                RESET_R(crate::FieldReader::new(bits))
            }
        }
        impl core::ops::Deref for RESET_R {
            type Target = crate::FieldReader<bool, bool>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        #[doc = "Field `reset` writer - "]
        pub struct RESET_W<'a> {
            w: &'a mut W,
        }
        impl<'a> RESET_W<'a> {
            #[doc = r"Sets the field bit"]
            #[inline(always)]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r"Clears the field bit"]
            #[inline(always)]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r"Writes raw bits to the field"]
            #[inline(always)]
            pub fn bit(self, value: bool) -> &'a mut W {
                self.w.bits = (self.w.bits & !0x01) | (value as u32 & 0x01);
                self.w
            }
        }
        impl R {
            #[doc = "Bit 0"]
            #[inline(always)]
            pub fn reset(&self) -> RESET_R {
                RESET_R::new((self.bits & 0x01) != 0)
            }
        }
        impl W {
            #[doc = "Bit 0"]
            #[inline(always)]
            pub fn reset(&mut self) -> RESET_W {
                RESET_W { w: self }
            }
            #[doc = "Writes raw bits to the register."]
            #[inline(always)]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.0.bits(bits);
                self
            }
        }
        #[doc = "Write a 1 to this field to force the device to reset\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [reset](index.html) module"]
        pub struct RESET_SPEC;
        impl crate::RegisterSpec for RESET_SPEC {
            type Ux = u32;
        }
        #[doc = "`read()` method returns [reset::R](R) reader structure"]
        impl crate::Readable for RESET_SPEC {
            type Reader = R;
        }
        #[doc = "`write(|w| ..)` method takes [reset::W](W) writer structure"]
        impl crate::Writable for RESET_SPEC {
            type Writer = W;
        }
        #[doc = "`reset()` method sets RESET to value 0"]
        impl crate::Resettable for RESET_SPEC {
            #[inline(always)]
            fn reset_value() -> Self::Ux {
                0
            }
        }
    }
    #[doc = "START_RUN register accessor: an alias for `Reg<START_RUN_SPEC>`"]
    pub type START_RUN = crate::Reg<start_run::START_RUN_SPEC>;
    #[doc = "Writing a 1 to this field while idle starts the transfer."]
    pub mod start_run {
        #[doc = "Register `START_RUN` reader"]
        pub struct R(crate::R<START_RUN_SPEC>);
        impl core::ops::Deref for R {
            type Target = crate::R<START_RUN_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl From<crate::R<START_RUN_SPEC>> for R {
            #[inline(always)]
            fn from(reader: crate::R<START_RUN_SPEC>) -> Self {
                R(reader)
            }
        }
        #[doc = "Register `START_RUN` writer"]
        pub struct W(crate::W<START_RUN_SPEC>);
        impl core::ops::Deref for W {
            type Target = crate::W<START_RUN_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl core::ops::DerefMut for W {
            #[inline(always)]
            fn deref_mut(&mut self) -> &mut Self::Target {
                &mut self.0
            }
        }
        impl From<crate::W<START_RUN_SPEC>> for W {
            #[inline(always)]
            fn from(writer: crate::W<START_RUN_SPEC>) -> Self {
                W(writer)
            }
        }
        #[doc = "Field `start_run` reader - "]
        pub struct START_RUN_R(crate::FieldReader<bool, bool>);
        impl START_RUN_R {
            #[inline(always)]
            pub(crate) fn new(bits: bool) -> Self {
                START_RUN_R(crate::FieldReader::new(bits))
            }
        }
        impl core::ops::Deref for START_RUN_R {
            type Target = crate::FieldReader<bool, bool>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        #[doc = "Field `start_run` writer - "]
        pub struct START_RUN_W<'a> {
            w: &'a mut W,
        }
        impl<'a> START_RUN_W<'a> {
            #[doc = r"Sets the field bit"]
            #[inline(always)]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r"Clears the field bit"]
            #[inline(always)]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r"Writes raw bits to the field"]
            #[inline(always)]
            pub fn bit(self, value: bool) -> &'a mut W {
                self.w.bits = (self.w.bits & !0x01) | (value as u32 & 0x01);
                self.w
            }
        }
        impl R {
            #[doc = "Bit 0"]
            #[inline(always)]
            pub fn start_run(&self) -> START_RUN_R {
                START_RUN_R::new((self.bits & 0x01) != 0)
            }
        }
        impl W {
            #[doc = "Bit 0"]
            #[inline(always)]
            pub fn start_run(&mut self) -> START_RUN_W {
                START_RUN_W { w: self }
            }
            #[doc = "Writes raw bits to the register."]
            #[inline(always)]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.0.bits(bits);
                self
            }
        }
        #[doc = "Writing a 1 to this field while idle starts the transfer.\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [start_run](index.html) module"]
        pub struct START_RUN_SPEC;
        impl crate::RegisterSpec for START_RUN_SPEC {
            type Ux = u32;
        }
        #[doc = "`read()` method returns [start_run::R](R) reader structure"]
        impl crate::Readable for START_RUN_SPEC {
            type Reader = R;
        }
        #[doc = "`write(|w| ..)` method takes [start_run::W](W) writer structure"]
        impl crate::Writable for START_RUN_SPEC {
            type Writer = W;
        }
        #[doc = "`reset()` method sets START_RUN to value 0"]
        impl crate::Resettable for START_RUN_SPEC {
            #[inline(always)]
            fn reset_value() -> Self::Ux {
                0
            }
        }
    }
    #[doc = "WAIT_ROW register accessor: an alias for `Reg<WAIT_ROW_SPEC>`"]
    pub type WAIT_ROW = crate::Reg<wait_row::WAIT_ROW_SPEC>;
    #[doc = "Writing a 1 to this field while running waits for the start of the next row."]
    pub mod wait_row {
        #[doc = "Register `WAIT_ROW` reader"]
        pub struct R(crate::R<WAIT_ROW_SPEC>);
        impl core::ops::Deref for R {
            type Target = crate::R<WAIT_ROW_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl From<crate::R<WAIT_ROW_SPEC>> for R {
            #[inline(always)]
            fn from(reader: crate::R<WAIT_ROW_SPEC>) -> Self {
                R(reader)
            }
        }
        #[doc = "Register `WAIT_ROW` writer"]
        pub struct W(crate::W<WAIT_ROW_SPEC>);
        impl core::ops::Deref for W {
            type Target = crate::W<WAIT_ROW_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl core::ops::DerefMut for W {
            #[inline(always)]
            fn deref_mut(&mut self) -> &mut Self::Target {
                &mut self.0
            }
        }
        impl From<crate::W<WAIT_ROW_SPEC>> for W {
            #[inline(always)]
            fn from(writer: crate::W<WAIT_ROW_SPEC>) -> Self {
                W(writer)
            }
        }
        #[doc = "Field `wait_row` reader - "]
        pub struct WAIT_ROW_R(crate::FieldReader<bool, bool>);
        impl WAIT_ROW_R {
            #[inline(always)]
            pub(crate) fn new(bits: bool) -> Self {
                WAIT_ROW_R(crate::FieldReader::new(bits))
            }
        }
        impl core::ops::Deref for WAIT_ROW_R {
            type Target = crate::FieldReader<bool, bool>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        #[doc = "Field `wait_row` writer - "]
        pub struct WAIT_ROW_W<'a> {
            w: &'a mut W,
        }
        impl<'a> WAIT_ROW_W<'a> {
            #[doc = r"Sets the field bit"]
            #[inline(always)]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r"Clears the field bit"]
            #[inline(always)]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r"Writes raw bits to the field"]
            #[inline(always)]
            pub fn bit(self, value: bool) -> &'a mut W {
                self.w.bits = (self.w.bits & !0x01) | (value as u32 & 0x01);
                self.w
            }
        }
        impl R {
            #[doc = "Bit 0"]
            #[inline(always)]
            pub fn wait_row(&self) -> WAIT_ROW_R {
                WAIT_ROW_R::new((self.bits & 0x01) != 0)
            }
        }
        impl W {
            #[doc = "Bit 0"]
            #[inline(always)]
            pub fn wait_row(&mut self) -> WAIT_ROW_W {
                WAIT_ROW_W { w: self }
            }
            #[doc = "Writes raw bits to the register."]
            #[inline(always)]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.0.bits(bits);
                self
            }
        }
        #[doc = "Writing a 1 to this field while running waits for the start of the next row.\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wait_row](index.html) module"]
        pub struct WAIT_ROW_SPEC;
        impl crate::RegisterSpec for WAIT_ROW_SPEC {
            type Ux = u32;
        }
        #[doc = "`read()` method returns [wait_row::R](R) reader structure"]
        impl crate::Readable for WAIT_ROW_SPEC {
            type Reader = R;
        }
        #[doc = "`write(|w| ..)` method takes [wait_row::W](W) writer structure"]
        impl crate::Writable for WAIT_ROW_SPEC {
            type Writer = W;
        }
        #[doc = "`reset()` method sets WAIT_ROW to value 0"]
        impl crate::Resettable for WAIT_ROW_SPEC {
            #[inline(always)]
            fn reset_value() -> Self::Ux {
                0
            }
        }
    }
    #[doc = "PIXELS_READY register accessor: an alias for `Reg<PIXELS_READY_SPEC>`"]
    pub type PIXELS_READY = crate::Reg<pixels_ready::PIXELS_READY_SPEC>;
    #[doc = "Whether we have 4 bytes of pixel data ready."]
    pub mod pixels_ready {
        #[doc = "Register `PIXELS_READY` reader"]
        pub struct R(crate::R<PIXELS_READY_SPEC>);
        impl core::ops::Deref for R {
            type Target = crate::R<PIXELS_READY_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl From<crate::R<PIXELS_READY_SPEC>> for R {
            #[inline(always)]
            fn from(reader: crate::R<PIXELS_READY_SPEC>) -> Self {
                R(reader)
            }
        }
        #[doc = "Register `PIXELS_READY` writer"]
        pub struct W(crate::W<PIXELS_READY_SPEC>);
        impl core::ops::Deref for W {
            type Target = crate::W<PIXELS_READY_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl core::ops::DerefMut for W {
            #[inline(always)]
            fn deref_mut(&mut self) -> &mut Self::Target {
                &mut self.0
            }
        }
        impl From<crate::W<PIXELS_READY_SPEC>> for W {
            #[inline(always)]
            fn from(writer: crate::W<PIXELS_READY_SPEC>) -> Self {
                W(writer)
            }
        }
        #[doc = "Field `pixels_ready` reader - "]
        pub struct PIXELS_READY_R(crate::FieldReader<bool, bool>);
        impl PIXELS_READY_R {
            #[inline(always)]
            pub(crate) fn new(bits: bool) -> Self {
                PIXELS_READY_R(crate::FieldReader::new(bits))
            }
        }
        impl core::ops::Deref for PIXELS_READY_R {
            type Target = crate::FieldReader<bool, bool>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        #[doc = "Field `pixels_ready` writer - "]
        pub struct PIXELS_READY_W<'a> {
            w: &'a mut W,
        }
        impl<'a> PIXELS_READY_W<'a> {
            #[doc = r"Sets the field bit"]
            #[inline(always)]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r"Clears the field bit"]
            #[inline(always)]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r"Writes raw bits to the field"]
            #[inline(always)]
            pub fn bit(self, value: bool) -> &'a mut W {
                self.w.bits = (self.w.bits & !0x01) | (value as u32 & 0x01);
                self.w
            }
        }
        impl R {
            #[doc = "Bit 0"]
            #[inline(always)]
            pub fn pixels_ready(&self) -> PIXELS_READY_R {
                PIXELS_READY_R::new((self.bits & 0x01) != 0)
            }
        }
        impl W {
            #[doc = "Bit 0"]
            #[inline(always)]
            pub fn pixels_ready(&mut self) -> PIXELS_READY_W {
                PIXELS_READY_W { w: self }
            }
            #[doc = "Writes raw bits to the register."]
            #[inline(always)]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.0.bits(bits);
                self
            }
        }
        #[doc = "Whether we have 4 bytes of pixel data ready.\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pixels_ready](index.html) module"]
        pub struct PIXELS_READY_SPEC;
        impl crate::RegisterSpec for PIXELS_READY_SPEC {
            type Ux = u32;
        }
        #[doc = "`read()` method returns [pixels_ready::R](R) reader structure"]
        impl crate::Readable for PIXELS_READY_SPEC {
            type Reader = R;
        }
        #[doc = "`write(|w| ..)` method takes [pixels_ready::W](W) writer structure"]
        impl crate::Writable for PIXELS_READY_SPEC {
            type Writer = W;
        }
        #[doc = "`reset()` method sets PIXELS_READY to value 0"]
        impl crate::Resettable for PIXELS_READY_SPEC {
            #[inline(always)]
            fn reset_value() -> Self::Ux {
                0
            }
        }
    }
    #[doc = "PIXELS register accessor: an alias for `Reg<PIXELS_SPEC>`"]
    pub type PIXELS = crate::Reg<pixels::PIXELS_SPEC>;
    #[doc = "4 bytes of pixel data."]
    pub mod pixels {
        #[doc = "Register `PIXELS` reader"]
        pub struct R(crate::R<PIXELS_SPEC>);
        impl core::ops::Deref for R {
            type Target = crate::R<PIXELS_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl From<crate::R<PIXELS_SPEC>> for R {
            #[inline(always)]
            fn from(reader: crate::R<PIXELS_SPEC>) -> Self {
                R(reader)
            }
        }
        #[doc = "Register `PIXELS` writer"]
        pub struct W(crate::W<PIXELS_SPEC>);
        impl core::ops::Deref for W {
            type Target = crate::W<PIXELS_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl core::ops::DerefMut for W {
            #[inline(always)]
            fn deref_mut(&mut self) -> &mut Self::Target {
                &mut self.0
            }
        }
        impl From<crate::W<PIXELS_SPEC>> for W {
            #[inline(always)]
            fn from(writer: crate::W<PIXELS_SPEC>) -> Self {
                W(writer)
            }
        }
        #[doc = "Field `pixels` reader - "]
        pub struct PIXELS_R(crate::FieldReader<u32, u32>);
        impl PIXELS_R {
            #[inline(always)]
            pub(crate) fn new(bits: u32) -> Self {
                PIXELS_R(crate::FieldReader::new(bits))
            }
        }
        impl core::ops::Deref for PIXELS_R {
            type Target = crate::FieldReader<u32, u32>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        #[doc = "Field `pixels` writer - "]
        pub struct PIXELS_W<'a> {
            w: &'a mut W,
        }
        impl<'a> PIXELS_W<'a> {
            #[doc = r"Writes raw bits to the field"]
            #[inline(always)]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                self.w.bits = value as u32;
                self.w
            }
        }
        impl R {
            #[doc = "Bits 0:31"]
            #[inline(always)]
            pub fn pixels(&self) -> PIXELS_R {
                PIXELS_R::new(self.bits as u32)
            }
        }
        impl W {
            #[doc = "Bits 0:31"]
            #[inline(always)]
            pub fn pixels(&mut self) -> PIXELS_W {
                PIXELS_W { w: self }
            }
            #[doc = "Writes raw bits to the register."]
            #[inline(always)]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.0.bits(bits);
                self
            }
        }
        #[doc = "4 bytes of pixel data.\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pixels](index.html) module"]
        pub struct PIXELS_SPEC;
        impl crate::RegisterSpec for PIXELS_SPEC {
            type Ux = u32;
        }
        #[doc = "`read()` method returns [pixels::R](R) reader structure"]
        impl crate::Readable for PIXELS_SPEC {
            type Reader = R;
        }
        #[doc = "`write(|w| ..)` method takes [pixels::W](W) writer structure"]
        impl crate::Writable for PIXELS_SPEC {
            type Writer = W;
        }
        #[doc = "`reset()` method sets PIXELS to value 0"]
        impl crate::Resettable for PIXELS_SPEC {
            #[inline(always)]
            fn reset_value() -> Self::Ux {
                0
            }
        }
    }
}
#[doc = "MCU_SPI"]
pub struct MCU_SPI {
    _marker: PhantomData<*const ()>,
}
unsafe impl Send for MCU_SPI {}
impl MCU_SPI {
    #[doc = r"Pointer to the register block"]
    pub const PTR: *const mcu_spi::RegisterBlock = 0xf000_1800 as *const _;
    #[doc = r"Return the pointer to the register block"]
    #[inline(always)]
    pub const fn ptr() -> *const mcu_spi::RegisterBlock {
        Self::PTR
    }
}
impl Deref for MCU_SPI {
    type Target = mcu_spi::RegisterBlock;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        unsafe { &*Self::PTR }
    }
}
impl core::fmt::Debug for MCU_SPI {
    fn fmt(&self, f: &mut core::fmt::Formatter) -> core::fmt::Result {
        f.debug_struct("MCU_SPI").finish()
    }
}
#[doc = "MCU_SPI"]
pub mod mcu_spi {
    #[doc = r"Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - SPI control register"]
        pub cr: crate::Reg<cr::CR_SPEC>,
        #[doc = "0x04 - SPI Status flags"]
        pub flags: crate::Reg<flags::FLAGS_SPEC>,
        #[doc = "0x08 - Transmit data register"]
        pub txd: crate::Reg<txd::TXD_SPEC>,
        #[doc = "0x0c - Receive data register"]
        pub rxd: crate::Reg<rxd::RXD_SPEC>,
    }
    #[doc = "CR register accessor: an alias for `Reg<CR_SPEC>`"]
    pub type CR = crate::Reg<cr::CR_SPEC>;
    #[doc = "SPI control register"]
    pub mod cr {
        #[doc = "Register `CR` reader"]
        pub struct R(crate::R<CR_SPEC>);
        impl core::ops::Deref for R {
            type Target = crate::R<CR_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl From<crate::R<CR_SPEC>> for R {
            #[inline(always)]
            fn from(reader: crate::R<CR_SPEC>) -> Self {
                R(reader)
            }
        }
        #[doc = "Register `CR` writer"]
        pub struct W(crate::W<CR_SPEC>);
        impl core::ops::Deref for W {
            type Target = crate::W<CR_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl core::ops::DerefMut for W {
            #[inline(always)]
            fn deref_mut(&mut self) -> &mut Self::Target {
                &mut self.0
            }
        }
        impl From<crate::W<CR_SPEC>> for W {
            #[inline(always)]
            fn from(writer: crate::W<CR_SPEC>) -> Self {
                W(writer)
            }
        }
        #[doc = "Field `cs` reader - CS line (bring low to select)"]
        pub struct CS_R(crate::FieldReader<bool, bool>);
        impl CS_R {
            #[inline(always)]
            pub(crate) fn new(bits: bool) -> Self {
                CS_R(crate::FieldReader::new(bits))
            }
        }
        impl core::ops::Deref for CS_R {
            type Target = crate::FieldReader<bool, bool>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        #[doc = "Field `cs` writer - CS line (bring low to select)"]
        pub struct CS_W<'a> {
            w: &'a mut W,
        }
        impl<'a> CS_W<'a> {
            #[doc = r"Sets the field bit"]
            #[inline(always)]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r"Clears the field bit"]
            #[inline(always)]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r"Writes raw bits to the field"]
            #[inline(always)]
            pub fn bit(self, value: bool) -> &'a mut W {
                self.w.bits = (self.w.bits & !0x01) | (value as u32 & 0x01);
                self.w
            }
        }
        #[doc = "Field `en` reader - Enable SPI"]
        pub struct EN_R(crate::FieldReader<bool, bool>);
        impl EN_R {
            #[inline(always)]
            pub(crate) fn new(bits: bool) -> Self {
                EN_R(crate::FieldReader::new(bits))
            }
        }
        impl core::ops::Deref for EN_R {
            type Target = crate::FieldReader<bool, bool>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        #[doc = "Field `en` writer - Enable SPI"]
        pub struct EN_W<'a> {
            w: &'a mut W,
        }
        impl<'a> EN_W<'a> {
            #[doc = r"Sets the field bit"]
            #[inline(always)]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r"Clears the field bit"]
            #[inline(always)]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r"Writes raw bits to the field"]
            #[inline(always)]
            pub fn bit(self, value: bool) -> &'a mut W {
                self.w.bits = (self.w.bits & !(0x01 << 1)) | ((value as u32 & 0x01) << 1);
                self.w
            }
        }
        impl R {
            #[doc = "Bit 0 - CS line (bring low to select)"]
            #[inline(always)]
            pub fn cs(&self) -> CS_R {
                CS_R::new((self.bits & 0x01) != 0)
            }
            #[doc = "Bit 1 - Enable SPI"]
            #[inline(always)]
            pub fn en(&self) -> EN_R {
                EN_R::new(((self.bits >> 1) & 0x01) != 0)
            }
        }
        impl W {
            #[doc = "Bit 0 - CS line (bring low to select)"]
            #[inline(always)]
            pub fn cs(&mut self) -> CS_W {
                CS_W { w: self }
            }
            #[doc = "Bit 1 - Enable SPI"]
            #[inline(always)]
            pub fn en(&mut self) -> EN_W {
                EN_W { w: self }
            }
            #[doc = "Writes raw bits to the register."]
            #[inline(always)]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.0.bits(bits);
                self
            }
        }
        #[doc = "SPI control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cr](index.html) module"]
        pub struct CR_SPEC;
        impl crate::RegisterSpec for CR_SPEC {
            type Ux = u32;
        }
        #[doc = "`read()` method returns [cr::R](R) reader structure"]
        impl crate::Readable for CR_SPEC {
            type Reader = R;
        }
        #[doc = "`write(|w| ..)` method takes [cr::W](W) writer structure"]
        impl crate::Writable for CR_SPEC {
            type Writer = W;
        }
        #[doc = "`reset()` method sets CR to value 0x01"]
        impl crate::Resettable for CR_SPEC {
            #[inline(always)]
            fn reset_value() -> Self::Ux {
                0x01
            }
        }
    }
    #[doc = "FLAGS register accessor: an alias for `Reg<FLAGS_SPEC>`"]
    pub type FLAGS = crate::Reg<flags::FLAGS_SPEC>;
    #[doc = "SPI Status flags"]
    pub mod flags {
        #[doc = "Register `FLAGS` reader"]
        pub struct R(crate::R<FLAGS_SPEC>);
        impl core::ops::Deref for R {
            type Target = crate::R<FLAGS_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl From<crate::R<FLAGS_SPEC>> for R {
            #[inline(always)]
            fn from(reader: crate::R<FLAGS_SPEC>) -> Self {
                R(reader)
            }
        }
        #[doc = "Register `FLAGS` writer"]
        pub struct W(crate::W<FLAGS_SPEC>);
        impl core::ops::Deref for W {
            type Target = crate::W<FLAGS_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl core::ops::DerefMut for W {
            #[inline(always)]
            fn deref_mut(&mut self) -> &mut Self::Target {
                &mut self.0
            }
        }
        impl From<crate::W<FLAGS_SPEC>> for W {
            #[inline(always)]
            fn from(writer: crate::W<FLAGS_SPEC>) -> Self {
                W(writer)
            }
        }
        #[doc = "Field `txe` reader - TX buffer empty"]
        pub struct TXE_R(crate::FieldReader<bool, bool>);
        impl TXE_R {
            #[inline(always)]
            pub(crate) fn new(bits: bool) -> Self {
                TXE_R(crate::FieldReader::new(bits))
            }
        }
        impl core::ops::Deref for TXE_R {
            type Target = crate::FieldReader<bool, bool>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        #[doc = "Field `txe` writer - TX buffer empty"]
        pub struct TXE_W<'a> {
            w: &'a mut W,
        }
        impl<'a> TXE_W<'a> {
            #[doc = r"Sets the field bit"]
            #[inline(always)]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r"Clears the field bit"]
            #[inline(always)]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r"Writes raw bits to the field"]
            #[inline(always)]
            pub fn bit(self, value: bool) -> &'a mut W {
                self.w.bits = (self.w.bits & !0x01) | (value as u32 & 0x01);
                self.w
            }
        }
        #[doc = "Field `rxe` reader - RX buffer empty"]
        pub struct RXE_R(crate::FieldReader<bool, bool>);
        impl RXE_R {
            #[inline(always)]
            pub(crate) fn new(bits: bool) -> Self {
                RXE_R(crate::FieldReader::new(bits))
            }
        }
        impl core::ops::Deref for RXE_R {
            type Target = crate::FieldReader<bool, bool>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        #[doc = "Field `rxe` writer - RX buffer empty"]
        pub struct RXE_W<'a> {
            w: &'a mut W,
        }
        impl<'a> RXE_W<'a> {
            #[doc = r"Sets the field bit"]
            #[inline(always)]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r"Clears the field bit"]
            #[inline(always)]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r"Writes raw bits to the field"]
            #[inline(always)]
            pub fn bit(self, value: bool) -> &'a mut W {
                self.w.bits = (self.w.bits & !(0x01 << 1)) | ((value as u32 & 0x01) << 1);
                self.w
            }
        }
        #[doc = "Field `ready` reader - Peripheral ready"]
        pub struct READY_R(crate::FieldReader<bool, bool>);
        impl READY_R {
            #[inline(always)]
            pub(crate) fn new(bits: bool) -> Self {
                READY_R(crate::FieldReader::new(bits))
            }
        }
        impl core::ops::Deref for READY_R {
            type Target = crate::FieldReader<bool, bool>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        #[doc = "Field `ready` writer - Peripheral ready"]
        pub struct READY_W<'a> {
            w: &'a mut W,
        }
        impl<'a> READY_W<'a> {
            #[doc = r"Sets the field bit"]
            #[inline(always)]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r"Clears the field bit"]
            #[inline(always)]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r"Writes raw bits to the field"]
            #[inline(always)]
            pub fn bit(self, value: bool) -> &'a mut W {
                self.w.bits = (self.w.bits & !(0x01 << 2)) | ((value as u32 & 0x01) << 2);
                self.w
            }
        }
        impl R {
            #[doc = "Bit 0 - TX buffer empty"]
            #[inline(always)]
            pub fn txe(&self) -> TXE_R {
                TXE_R::new((self.bits & 0x01) != 0)
            }
            #[doc = "Bit 1 - RX buffer empty"]
            #[inline(always)]
            pub fn rxe(&self) -> RXE_R {
                RXE_R::new(((self.bits >> 1) & 0x01) != 0)
            }
            #[doc = "Bit 2 - Peripheral ready"]
            #[inline(always)]
            pub fn ready(&self) -> READY_R {
                READY_R::new(((self.bits >> 2) & 0x01) != 0)
            }
        }
        impl W {
            #[doc = "Bit 0 - TX buffer empty"]
            #[inline(always)]
            pub fn txe(&mut self) -> TXE_W {
                TXE_W { w: self }
            }
            #[doc = "Bit 1 - RX buffer empty"]
            #[inline(always)]
            pub fn rxe(&mut self) -> RXE_W {
                RXE_W { w: self }
            }
            #[doc = "Bit 2 - Peripheral ready"]
            #[inline(always)]
            pub fn ready(&mut self) -> READY_W {
                READY_W { w: self }
            }
            #[doc = "Writes raw bits to the register."]
            #[inline(always)]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.0.bits(bits);
                self
            }
        }
        #[doc = "SPI Status flags\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [flags](index.html) module"]
        pub struct FLAGS_SPEC;
        impl crate::RegisterSpec for FLAGS_SPEC {
            type Ux = u32;
        }
        #[doc = "`read()` method returns [flags::R](R) reader structure"]
        impl crate::Readable for FLAGS_SPEC {
            type Reader = R;
        }
        #[doc = "`write(|w| ..)` method takes [flags::W](W) writer structure"]
        impl crate::Writable for FLAGS_SPEC {
            type Writer = W;
        }
        #[doc = "`reset()` method sets FLAGS to value 0x07"]
        impl crate::Resettable for FLAGS_SPEC {
            #[inline(always)]
            fn reset_value() -> Self::Ux {
                0x07
            }
        }
    }
    #[doc = "TXD register accessor: an alias for `Reg<TXD_SPEC>`"]
    pub type TXD = crate::Reg<txd::TXD_SPEC>;
    #[doc = "Transmit data register"]
    pub mod txd {
        #[doc = "Register `TXD` reader"]
        pub struct R(crate::R<TXD_SPEC>);
        impl core::ops::Deref for R {
            type Target = crate::R<TXD_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl From<crate::R<TXD_SPEC>> for R {
            #[inline(always)]
            fn from(reader: crate::R<TXD_SPEC>) -> Self {
                R(reader)
            }
        }
        #[doc = "Register `TXD` writer"]
        pub struct W(crate::W<TXD_SPEC>);
        impl core::ops::Deref for W {
            type Target = crate::W<TXD_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl core::ops::DerefMut for W {
            #[inline(always)]
            fn deref_mut(&mut self) -> &mut Self::Target {
                &mut self.0
            }
        }
        impl From<crate::W<TXD_SPEC>> for W {
            #[inline(always)]
            fn from(writer: crate::W<TXD_SPEC>) -> Self {
                W(writer)
            }
        }
        #[doc = "Field `txd` reader - "]
        pub struct TXD_R(crate::FieldReader<u8, u8>);
        impl TXD_R {
            #[inline(always)]
            pub(crate) fn new(bits: u8) -> Self {
                TXD_R(crate::FieldReader::new(bits))
            }
        }
        impl core::ops::Deref for TXD_R {
            type Target = crate::FieldReader<u8, u8>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        #[doc = "Field `txd` writer - "]
        pub struct TXD_W<'a> {
            w: &'a mut W,
        }
        impl<'a> TXD_W<'a> {
            #[doc = r"Writes raw bits to the field"]
            #[inline(always)]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                self.w.bits = (self.w.bits & !0xff) | (value as u32 & 0xff);
                self.w
            }
        }
        impl R {
            #[doc = "Bits 0:7"]
            #[inline(always)]
            pub fn txd(&self) -> TXD_R {
                TXD_R::new((self.bits & 0xff) as u8)
            }
        }
        impl W {
            #[doc = "Bits 0:7"]
            #[inline(always)]
            pub fn txd(&mut self) -> TXD_W {
                TXD_W { w: self }
            }
            #[doc = "Writes raw bits to the register."]
            #[inline(always)]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.0.bits(bits);
                self
            }
        }
        #[doc = "Transmit data register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [txd](index.html) module"]
        pub struct TXD_SPEC;
        impl crate::RegisterSpec for TXD_SPEC {
            type Ux = u32;
        }
        #[doc = "`read()` method returns [txd::R](R) reader structure"]
        impl crate::Readable for TXD_SPEC {
            type Reader = R;
        }
        #[doc = "`write(|w| ..)` method takes [txd::W](W) writer structure"]
        impl crate::Writable for TXD_SPEC {
            type Writer = W;
        }
        #[doc = "`reset()` method sets TXD to value 0"]
        impl crate::Resettable for TXD_SPEC {
            #[inline(always)]
            fn reset_value() -> Self::Ux {
                0
            }
        }
    }
    #[doc = "RXD register accessor: an alias for `Reg<RXD_SPEC>`"]
    pub type RXD = crate::Reg<rxd::RXD_SPEC>;
    #[doc = "Receive data register"]
    pub mod rxd {
        #[doc = "Register `RXD` reader"]
        pub struct R(crate::R<RXD_SPEC>);
        impl core::ops::Deref for R {
            type Target = crate::R<RXD_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl From<crate::R<RXD_SPEC>> for R {
            #[inline(always)]
            fn from(reader: crate::R<RXD_SPEC>) -> Self {
                R(reader)
            }
        }
        #[doc = "Register `RXD` writer"]
        pub struct W(crate::W<RXD_SPEC>);
        impl core::ops::Deref for W {
            type Target = crate::W<RXD_SPEC>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        impl core::ops::DerefMut for W {
            #[inline(always)]
            fn deref_mut(&mut self) -> &mut Self::Target {
                &mut self.0
            }
        }
        impl From<crate::W<RXD_SPEC>> for W {
            #[inline(always)]
            fn from(writer: crate::W<RXD_SPEC>) -> Self {
                W(writer)
            }
        }
        #[doc = "Field `rxd` reader - "]
        pub struct RXD_R(crate::FieldReader<u8, u8>);
        impl RXD_R {
            #[inline(always)]
            pub(crate) fn new(bits: u8) -> Self {
                RXD_R(crate::FieldReader::new(bits))
            }
        }
        impl core::ops::Deref for RXD_R {
            type Target = crate::FieldReader<u8, u8>;
            #[inline(always)]
            fn deref(&self) -> &Self::Target {
                &self.0
            }
        }
        #[doc = "Field `rxd` writer - "]
        pub struct RXD_W<'a> {
            w: &'a mut W,
        }
        impl<'a> RXD_W<'a> {
            #[doc = r"Writes raw bits to the field"]
            #[inline(always)]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                self.w.bits = (self.w.bits & !0xff) | (value as u32 & 0xff);
                self.w
            }
        }
        impl R {
            #[doc = "Bits 0:7"]
            #[inline(always)]
            pub fn rxd(&self) -> RXD_R {
                RXD_R::new((self.bits & 0xff) as u8)
            }
        }
        impl W {
            #[doc = "Bits 0:7"]
            #[inline(always)]
            pub fn rxd(&mut self) -> RXD_W {
                RXD_W { w: self }
            }
            #[doc = "Writes raw bits to the register."]
            #[inline(always)]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.0.bits(bits);
                self
            }
        }
        #[doc = "Receive data register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rxd](index.html) module"]
        pub struct RXD_SPEC;
        impl crate::RegisterSpec for RXD_SPEC {
            type Ux = u32;
        }
        #[doc = "`read()` method returns [rxd::R](R) reader structure"]
        impl crate::Readable for RXD_SPEC {
            type Reader = R;
        }
        #[doc = "`write(|w| ..)` method takes [rxd::W](W) writer structure"]
        impl crate::Writable for RXD_SPEC {
            type Writer = W;
        }
        #[doc = "`reset()` method sets RXD to value 0"]
        impl crate::Resettable for RXD_SPEC {
            #[inline(always)]
            fn reset_value() -> Self::Ux {
                0
            }
        }
    }
}
#[no_mangle]
static mut DEVICE_PERIPHERALS: bool = false;
#[doc = r"All the peripherals"]
#[allow(non_snake_case)]
pub struct Peripherals {
    #[doc = "SPIFLASH_PHY"]
    pub SPIFLASH_PHY: SPIFLASH_PHY,
    #[doc = "CAM_CONTROL"]
    pub CAM_CONTROL: CAM_CONTROL,
    #[doc = "MCU_SPI"]
    pub MCU_SPI: MCU_SPI,
}
impl Peripherals {
    #[doc = r"Returns all the peripherals *once*"]
    #[inline]
    pub fn take() -> Option<Self> {
        riscv::interrupt::free(|_| {
            if unsafe { DEVICE_PERIPHERALS } {
                None
            } else {
                Some(unsafe { Peripherals::steal() })
            }
        })
    }
    #[doc = r"Unchecked version of `Peripherals::take`"]
    #[inline]
    pub unsafe fn steal() -> Self {
        DEVICE_PERIPHERALS = true;
        Peripherals {
            SPIFLASH_PHY: SPIFLASH_PHY {
                _marker: PhantomData,
            },
            CAM_CONTROL: CAM_CONTROL {
                _marker: PhantomData,
            },
            MCU_SPI: MCU_SPI {
                _marker: PhantomData,
            },
        }
    }
}
