//--------------------------------------------------------------------------------
// Auto-generated by LiteX (--------) on 2024-02-28 12:38:45
//--------------------------------------------------------------------------------
#include <generated/soc.h>
#ifndef __GENERATED_CSR_H
#define __GENERATED_CSR_H
#include <stdint.h>
#include <system.h>
#ifndef CSR_ACCESSORS_DEFINED
#include <hw/common.h>
#endif /* ! CSR_ACCESSORS_DEFINED */
#ifndef CSR_BASE
#define CSR_BASE 0xf0000000L
#endif

/* spiflash_phy */
#define CSR_SPIFLASH_PHY_BASE (CSR_BASE + 0x800L)
#define CSR_SPIFLASH_PHY_CLK_DIVISOR_ADDR (CSR_BASE + 0x800L)
#define CSR_SPIFLASH_PHY_CLK_DIVISOR_SIZE 1
static inline uint32_t spiflash_phy_clk_divisor_read(void) {
	return csr_read_simple(CSR_BASE + 0x800L);
}
static inline void spiflash_phy_clk_divisor_write(uint32_t v) {
	csr_write_simple(v, CSR_BASE + 0x800L);
}

/* cam_control */
#define CSR_CAM_CONTROL_BASE (CSR_BASE + 0x1000L)
#define CSR_CAM_CONTROL_RUNNING_ADDR (CSR_BASE + 0x1000L)
#define CSR_CAM_CONTROL_RUNNING_SIZE 1
static inline uint32_t cam_control_running_read(void) {
	return csr_read_simple(CSR_BASE + 0x1000L);
}
#define CSR_CAM_CONTROL_IDLE_ADDR (CSR_BASE + 0x1004L)
#define CSR_CAM_CONTROL_IDLE_SIZE 1
static inline uint32_t cam_control_idle_read(void) {
	return csr_read_simple(CSR_BASE + 0x1004L);
}
#define CSR_CAM_CONTROL_RESET_ADDR (CSR_BASE + 0x1008L)
#define CSR_CAM_CONTROL_RESET_SIZE 1
static inline uint32_t cam_control_reset_read(void) {
	return csr_read_simple(CSR_BASE + 0x1008L);
}
static inline void cam_control_reset_write(uint32_t v) {
	csr_write_simple(v, CSR_BASE + 0x1008L);
}
#define CSR_CAM_CONTROL_START_RUN_ADDR (CSR_BASE + 0x100cL)
#define CSR_CAM_CONTROL_START_RUN_SIZE 1
static inline uint32_t cam_control_start_run_read(void) {
	return csr_read_simple(CSR_BASE + 0x100cL);
}
static inline void cam_control_start_run_write(uint32_t v) {
	csr_write_simple(v, CSR_BASE + 0x100cL);
}
#define CSR_CAM_CONTROL_WAIT_ROW_ADDR (CSR_BASE + 0x1010L)
#define CSR_CAM_CONTROL_WAIT_ROW_SIZE 1
static inline uint32_t cam_control_wait_row_read(void) {
	return csr_read_simple(CSR_BASE + 0x1010L);
}
static inline void cam_control_wait_row_write(uint32_t v) {
	csr_write_simple(v, CSR_BASE + 0x1010L);
}
#define CSR_CAM_CONTROL_PIXELS_READY_ADDR (CSR_BASE + 0x1014L)
#define CSR_CAM_CONTROL_PIXELS_READY_SIZE 1
static inline uint32_t cam_control_pixels_ready_read(void) {
	return csr_read_simple(CSR_BASE + 0x1014L);
}
#define CSR_CAM_CONTROL_PIXELS_ADDR (CSR_BASE + 0x1018L)
#define CSR_CAM_CONTROL_PIXELS_SIZE 1
static inline uint32_t cam_control_pixels_read(void) {
	return csr_read_simple(CSR_BASE + 0x1018L);
}

/* mcu_spi */
#define CSR_MCU_SPI_BASE (CSR_BASE + 0x1800L)
#define CSR_MCU_SPI_CR_ADDR (CSR_BASE + 0x1800L)
#define CSR_MCU_SPI_CR_SIZE 1
static inline uint32_t mcu_spi_cr_read(void) {
	return csr_read_simple(CSR_BASE + 0x1800L);
}
static inline void mcu_spi_cr_write(uint32_t v) {
	csr_write_simple(v, CSR_BASE + 0x1800L);
}
#define CSR_MCU_SPI_CR_CS_OFFSET 0
#define CSR_MCU_SPI_CR_CS_SIZE 1
static inline uint32_t mcu_spi_cr_cs_extract(uint32_t oldword) {
	uint32_t mask = ((uint32_t)(1 << 1)-1);
	return ( (oldword >> 0) & mask );
}
static inline uint32_t mcu_spi_cr_cs_read(void) {
	uint32_t word = mcu_spi_cr_read();
	return mcu_spi_cr_cs_extract(word);
}
static inline uint32_t mcu_spi_cr_cs_replace(uint32_t oldword, uint32_t plain_value) {
	uint32_t mask = ((uint32_t)(1 << 1)-1);
	return (oldword & (~(mask << 0))) | (mask & plain_value)<< 0 ;
}
static inline void mcu_spi_cr_cs_write(uint32_t plain_value) {
	uint32_t oldword = mcu_spi_cr_read();
	uint32_t newword = mcu_spi_cr_cs_replace(oldword, plain_value);
	mcu_spi_cr_write(newword);
}
#define CSR_MCU_SPI_CR_EN_OFFSET 1
#define CSR_MCU_SPI_CR_EN_SIZE 1
static inline uint32_t mcu_spi_cr_en_extract(uint32_t oldword) {
	uint32_t mask = ((uint32_t)(1 << 1)-1);
	return ( (oldword >> 1) & mask );
}
static inline uint32_t mcu_spi_cr_en_read(void) {
	uint32_t word = mcu_spi_cr_read();
	return mcu_spi_cr_en_extract(word);
}
static inline uint32_t mcu_spi_cr_en_replace(uint32_t oldword, uint32_t plain_value) {
	uint32_t mask = ((uint32_t)(1 << 1)-1);
	return (oldword & (~(mask << 1))) | (mask & plain_value)<< 1 ;
}
static inline void mcu_spi_cr_en_write(uint32_t plain_value) {
	uint32_t oldword = mcu_spi_cr_read();
	uint32_t newword = mcu_spi_cr_en_replace(oldword, plain_value);
	mcu_spi_cr_write(newword);
}
#define CSR_MCU_SPI_FLAGS_ADDR (CSR_BASE + 0x1804L)
#define CSR_MCU_SPI_FLAGS_SIZE 1
static inline uint32_t mcu_spi_flags_read(void) {
	return csr_read_simple(CSR_BASE + 0x1804L);
}
#define CSR_MCU_SPI_FLAGS_TXE_OFFSET 0
#define CSR_MCU_SPI_FLAGS_TXE_SIZE 1
static inline uint32_t mcu_spi_flags_txe_extract(uint32_t oldword) {
	uint32_t mask = ((uint32_t)(1 << 1)-1);
	return ( (oldword >> 0) & mask );
}
static inline uint32_t mcu_spi_flags_txe_read(void) {
	uint32_t word = mcu_spi_flags_read();
	return mcu_spi_flags_txe_extract(word);
}
#define CSR_MCU_SPI_FLAGS_RXE_OFFSET 1
#define CSR_MCU_SPI_FLAGS_RXE_SIZE 1
static inline uint32_t mcu_spi_flags_rxe_extract(uint32_t oldword) {
	uint32_t mask = ((uint32_t)(1 << 1)-1);
	return ( (oldword >> 1) & mask );
}
static inline uint32_t mcu_spi_flags_rxe_read(void) {
	uint32_t word = mcu_spi_flags_read();
	return mcu_spi_flags_rxe_extract(word);
}
#define CSR_MCU_SPI_FLAGS_READY_OFFSET 2
#define CSR_MCU_SPI_FLAGS_READY_SIZE 1
static inline uint32_t mcu_spi_flags_ready_extract(uint32_t oldword) {
	uint32_t mask = ((uint32_t)(1 << 1)-1);
	return ( (oldword >> 2) & mask );
}
static inline uint32_t mcu_spi_flags_ready_read(void) {
	uint32_t word = mcu_spi_flags_read();
	return mcu_spi_flags_ready_extract(word);
}
#define CSR_MCU_SPI_TXD_ADDR (CSR_BASE + 0x1808L)
#define CSR_MCU_SPI_TXD_SIZE 1
static inline uint32_t mcu_spi_txd_read(void) {
	return csr_read_simple(CSR_BASE + 0x1808L);
}
static inline void mcu_spi_txd_write(uint32_t v) {
	csr_write_simple(v, CSR_BASE + 0x1808L);
}
#define CSR_MCU_SPI_RXD_ADDR (CSR_BASE + 0x180cL)
#define CSR_MCU_SPI_RXD_SIZE 1
static inline uint32_t mcu_spi_rxd_read(void) {
	return csr_read_simple(CSR_BASE + 0x180cL);
}

#endif
